import { Controller, EventListenerController, extractEventTargets } from '@a11d/lit';
import { ResizeController } from '@3mo/resize-observer';
import { Throttler } from '@3mo/throttler';
export class PointerHoverController extends Controller {
    get hover() { return this._hover; }
    constructor(host, options) {
        var _a, _b;
        super(host);
        this.host = host;
        this.options = options;
        this._hover = false;
        this.throttler = new Throttler(10);
        this.pointerEnter = new EventListenerController(this.host, {
            type: 'pointerenter',
            target: (_a = this.options) === null || _a === void 0 ? void 0 : _a.target,
            listener: () => this.checkHover()
        });
        this.pointerLeave = new EventListenerController(this.host, {
            type: 'pointerleave',
            target: (_b = this.options) === null || _b === void 0 ? void 0 : _b.target,
            listener: () => this.checkHover()
        });
        this.resizeController = new ResizeController(this.host, {
            target: this.host,
            callback: () => this.checkHover()
        });
    }
    async checkHover() {
        var _a, _b, _c;
        await this.throttler.throttle();
        const elements = await extractEventTargets.call(this.host, (_a = this.options) === null || _a === void 0 ? void 0 : _a.target);
        const hover = elements.some(e => e.matches(':hover'));
        if (this._hover !== hover) {
            this._hover = hover;
            (_c = (_b = this.options) === null || _b === void 0 ? void 0 : _b.handleHoverChange) === null || _c === void 0 ? void 0 : _c.call(_b, hover);
            this.host.requestUpdate();
        }
    }
}
